#include <GL/glut.h>

// Generic 3D Rectangle
// starting coords, ending coords, color
void tdrect(GLfloat x1, GLfloat y1, GLfloat z1, GLfloat x2, GLfloat y2, GLfloat z2, GLfloat inputr, GLfloat inputg, GLfloat inputb)
{
	// Back face
	glBegin(GL_POLYGON);
		glColor3f(inputr-0.2, inputg, inputb);
		glVertex3f(x1, y1, z2);
		glColor3f(inputr+0.2, inputg, inputb);
		glVertex3f(x1, y2, z2);
		glColor3f(inputr, inputg, inputb);
		glVertex3f(x2, y2, z2);
		glColor3f(inputr, inputg+0.1, inputb);
		glVertex3f(x2, y1, z2);
	glEnd();

	// Left face
	glBegin(GL_POLYGON);
		glColor3f(inputr, inputg, inputb);
		glVertex3f(x1, y1, z1);
		glColor3f(inputr, inputg-0.1, inputb);
		glVertex3f(x1, y2, z1);
		glColor3f(inputr+0.2, inputg, inputb);
		glVertex3f(x1, y2, z2);
		glColor3f(inputr-0.2, inputg, inputb);
		glVertex3f(x1, y1, z2);
	glEnd();

	// Top face
	glBegin(GL_POLYGON);
		glColor3f(inputr-0.2, inputg+0.1, inputb);
		glVertex3f(x2, y2, z1);
		glColor3f(inputr, inputg-0.1, inputb);
		glVertex3f(x1, y2, z1);
		glColor3f(inputr+0.2, inputg, inputb);
		glVertex3f(x1, y2, z2);
		glColor3f(inputr, inputg, inputb);
		glVertex3f(x2, y2, z2);
	glEnd();

	// Right face
	glBegin(GL_POLYGON);
		glColor3f(inputr-0.2, inputg-0.1, inputb);
		glVertex3f(x2, y1, z1);
		glColor3f(inputr-0.2, inputg+0.1, inputb);
		glVertex3f(x2, y2, z1);
		glColor3f(inputr, inputg, inputb);
		glVertex3f(x2, y2, z2);
		glColor3f(inputr, inputg+0.1, inputb);
		glVertex3f(x2, y1, z2);
	glEnd();

	// Bottom face
	glBegin(GL_POLYGON);
		glColor3f(inputr-0.2, inputg-0.1, inputb);
		glVertex3f(x2, y1, z1);
		glColor3f(inputr, inputg, inputb);
		glVertex3f(x1, y1, z1);
		glColor3f(inputr-0.2, inputg, inputb);
		glVertex3f(x1, y1, z2);
		glColor3f(inputr, inputg+0.1, inputb);
		glVertex3f(x2, y1, z2);
	glEnd();

	// Front face
	glBegin(GL_POLYGON);
		glColor3f(inputr, inputg, inputb);
		glVertex3f(x1, y1, z1);
		glColor3f(inputr, inputg-0.1, inputb);
		glVertex3f(x1, y2, z1);
		glColor3f(inputr-0.2, inputg+0.1, inputb);
		glVertex3f(x2, y2, z1);
		glColor3f(inputr-0.2, inputg-0.1, inputb);
		glVertex3f(x2, y1, z1);
	glEnd();
}
